-- name: [CS] BigNoseBug model
-- description: [CS] Bug model by GeloxNG.
-- deluxe: true

if SM64COOPDX_VERSION == nil then
    local first = false
    hook_event(HOOK_ON_LEVEL_INIT, function()
        if not first then
            first = true
            play_sound(SOUND_MENU_CAMERA_BUZZ, gMarioStates[0].marioObj.header.gfx.cameraToObject)
            djui_chat_message_create("\\#ffa0a0\\Bug Model is not supported with sm64ex-coop\nas it uses sm64coopdx exclusive Lua functionality.\n\\#dcdcdc\\To play this mod, try out sm64coopdx at\n\\#7f7fff\\https://sm64coopdx.com")
        end
    end)
    return
end
if not _G.charSelectExists then
    local first = false
    hook_event(HOOK_ON_LEVEL_INIT, function()
        if not first then
            first = true
            play_sound(SOUND_MENU_CAMERA_BUZZ, gGlobalSoundSource)
            djui_chat_message_create("\\#ffffa0\\Bug model requires Character Select to be enabled.\nPlease rehost with it enabled.")
        end
    end)
    return
end

local E_MODEL_BUG = smlua_model_util_get_id("bug_geo")

local TEX_BUG = get_texture_info("bug_icon")

local capBug = {
    normal = smlua_model_util_get_id("bug_cap_geo"),
    wing = smlua_model_util_get_id("bug_wing_cap_geo"),
    metal = smlua_model_util_get_id("bug_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("bug_metal_wing_cap_geo")
}

local HEALTH_METER_BUG= {
    label = {
        left = get_texture_info("power_meter_left_bug"),
        right = get_texture_info("power_meter_right_bug"),
    },
    pie = {
        [1] = get_texture_info("hp-pie-1-bug"),
        [2] = get_texture_info("hp-pie-2-bug"),
        [3] = get_texture_info("hp-pie-3-bug"),
        [4] = get_texture_info("hp-pie-4-bug"),
        [5] = get_texture_info("hp-pie-5-bug"),
        [6] = get_texture_info("hp-pie-6-bug"),
        [7] = get_texture_info("hp-pie-7-bug"),
        [8] = get_texture_info("hp-pie-8-bug"),
    }
}

local VOICETABLE_BUG = {
    [CHAR_SOUND_ATTACKED] = "bignosebug_hurt_hard.ogg",
    [CHAR_SOUND_GROUND_POUND_WAH] = "bignosebug_wah.ogg",
    [CHAR_SOUND_HAHA] = "bignosebug_haahaa.ogg",
    [CHAR_SOUND_HAHA_2] = "bignosebug_haahaa.ogg",
    [CHAR_SOUND_HERE_WE_GO] = "bignosebug_here_we_go.ogg",
    [CHAR_SOUND_HOOHOO] = "bignosebug_jump.ogg",
    [CHAR_SOUND_ON_FIRE] = "bignosebug_burning.ogg",
    [CHAR_SOUND_OOOF] = "bignosebug_oof.ogg",
    [CHAR_SOUND_OOOF2] = "bignosebug_oof_2.ogg",
    [CHAR_SOUND_PUNCH_HOO] = "bignosebug_hoo.ogg",
    [CHAR_SOUND_PUNCH_WAH] = "bignosebug_wah.ogg",
    [CHAR_SOUND_PUNCH_YAH] = "bignosebug_yah.ogg",
    [CHAR_SOUND_SO_LONGA_BOWSER] = "bignosebug_bowser.ogg",
    [CHAR_SOUND_TWIRL_BOUNCE] = "bignosebug_boing.ogg",
    [CHAR_SOUND_WAAAOOOW] = "bignosebug_fall.ogg",
    [CHAR_SOUND_WAH2] = "bignosebug_jump.ogg",
    [CHAR_SOUND_WHOA] = "bignosebug_woah.ogg",
    [CHAR_SOUND_YAHOO] = "bignosebug_yahoo.ogg",
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {"bignosebug_yahoo.ogg", "bignosebug_yippee.ogg"},
    [CHAR_SOUND_YAH_WAH_HOO] = {"bignosebug_yah.ogg", "bignosebug_wah.ogg", "bignosebug_hoo.ogg"},
    [CHAR_SOUND_OKEY_DOKEY] = "bignosebug_okay.ogg",
    [CHAR_SOUND_LETS_A_GO] = "bignosebug_lets_a_go.ogg",
    [CHAR_SOUND_DYING] = "bignosebug_dead.ogg",
    [CHAR_SOUND_DROWNING] = "bignosebug_drowning.ogg",
    [CHAR_SOUND_EEUH] = "bignosebug_eugh.ogg",
    [CHAR_SOUND_MAMA_MIA] = "bignosebug_ooh.ogg",
    [CHAR_SOUND_DOH] = "bignosebug_oof.ogg",
    [CHAR_SOUND_HRMM] = "bignosebug_pickup.ogg",
    [CHAR_SOUND_PANTING] = "bignosebug_pant.ogg",
    [CHAR_SOUND_UH] = "bignosebug_oof.ogg",
    [CHAR_SOUND_SNORING1] = "bignosebug_snore.ogg",
    [CHAR_SOUND_SNORING2] = "bignosebug_snore2.ogg",
    [CHAR_SOUND_SNORING3] = {"bignosebug_snore2.ogg", "bignosebug_snore.ogg"},
    [CHAR_SOUND_YAWNING] = "bignosebug_yawn.ogg",
    [CHAR_SOUND_IMA_TIRED] = "bignosebug_im-a tired.ogg"
}


_G.charSelect.character_add("Bug", {"Owner of the Dream Grove Gardens", "aswell as the local mascot", ""}, "GeloxNG", { r = 158, g = 32, b = 253 }, E_MODEL_BUG, CT_MARIO, TEX_BUG)
_G.charSelect.character_add_voice(E_MODEL_BUG, VOICETABLE_BUG)
_G.charSelect.character_add_caps(E_MODEL_BUG, capBug)
_G.charSelect.character_add_health_meter(_G.charSelect.character_get_number_from_string("Bug"), HEALTH_METER_BUG)

hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
    if _G.charSelect.character_get_voice(m) == VOICETABLE_BUG then return _G.charSelect.voice.sound(m, sound) end
end)
hook_event(HOOK_MARIO_UPDATE, function (m)
    if _G.charSelect.character_get_voice(m) == VOICETABLE_BUG then return _G.charSelect.voice.snore(m) end
end)